//
//  Created by Thomas Jannaud on 18/08/08.
//  Copyright 2008 Jannaud's Technical Company. All rights reserved.
//

#import "Partie.h"
#import "MyView.h"
#import "animation.h"
#import "Controleur.h"
#import "Preference.h"

@interface Partie (PrivateMethods)
-(void) gagner;
-(void) mourir;
@end

@implementation Partie
-(id) init:(MyView*) window: (Controleur*) acontrolor {
	if (self = [super init]) {
		dessin = window;
		controlor = acontrolor;
		
		NSBundle* bundle = [NSBundle mainBundle];
		NSString* son0 = [bundle pathForResource:@"BaseballBatRelease" ofType:@"wav"];
		NSString* son1 = [bundle pathForResource:@"Communicator" ofType:@"wav"];
		NSString* son2 = [bundle pathForResource:@"CursorSelect" ofType:@"wav"];
		NSString* son3 = [bundle pathForResource:@"DragonBallImpact" ofType:@"wav"];
		
		Sons[0] = [[NSSound alloc] initWithContentsOfFile:son0 byReference:YES];
		Sons[1] = [[NSSound alloc] initWithContentsOfFile:son1 byReference:YES];
		Sons[2] = [[NSSound alloc] initWithContentsOfFile:son2 byReference:YES];
		Sons[3] = [[NSSound alloc] initWithContentsOfFile:son3 byReference:YES];
	}
	
	return self;
}

-(void) animer {
	animation* toto = [[animation alloc] init:nb :0.7 :YES :NO :self :@selector(animation_step:) :@selector(animation_fin)];
	[toto lancer];
}

-(void) start:(OptionDeJeu) gameOption {
	attend_click = NO;
	nb = 1;
	option = gameOption;
	vies = (option == MortSubite) ? 1 : 2;
	
	srandom([NSDate timeIntervalSinceReferenceDate]);
	for(int i = 0; i < 100; i++)
		liste[i] = random() % 4; // random : un entier entre 0 et 2^32
	
	animation* toto = [[animation alloc] init:1 :1.0 :NO :YES :self :@selector(selecteur_nul:) :@selector(animer)];
	[toto lancer];
}

-(void) animation_step: (int)etape {
	[Sons[liste[etape]] play];
	[dessin animer:liste[etape]];
}

-(void) animation_fin {
	attend_click = YES;
	numero_en_cours = 0;
}

-(void) next_step {
	nb++;
	if (nb == 100) {
		[self gagner];
		return;
	}
	[controlor info:(@"")];
	if (option == DeuxViesParTour)
		vies = 2;
	attend_click = NO;
	animation* toto = [[animation alloc] init:1 :1.0 :NO :YES :self :@selector(selecteur_nul:) :@selector(animer)] ;
	[toto lancer];
}

-(void) this_step {
	attend_click = NO;
	animation* toto = [[animation alloc] init:1 :1.0 :NO :YES :self :@selector(selecteur_nul:) :@selector(animer)] ;
	[toto lancer];
}


-(BOOL) recoitclic:(int) carre {
	if (!attend_click)
		return NO;
	
	[Sons[carre] play];
	
	if (liste[numero_en_cours] == carre) {
		numero_en_cours++;
		if (numero_en_cours == nb)
			[self next_step];
	}
	else {
		vies--;
		if (vies == 0)
			[self mourir];
		else {
			[controlor info:(@"1 vie restante")];
			[self this_step];
		}
	}
	return YES;
}

-(void) mourir {
	attend_click = NO;
	nb--;
	NSNumber* r = [NSNumber numberWithInt:nb];
	[controlor info:[@"perdu\nétape " stringByAppendingString:[r stringValue]]];
	int a = [Preference getRecord:option];
	if (nb > a) {
		[Preference setRecord:option:nb];
		[controlor show_record];
	}
	[controlor raz];
	[controlor end_game];
}

-(void) gagner {
	attend_click = NO;
	[controlor info:@"bravo\nétape 100"];
	[controlor raz];
	[controlor end_game];
	[Preference setRecord:option:100];
	[controlor show_record];
}

-(void) selecteur_nul:(int) a {
	return;
}
@end
