//
//  Preference.m
//  Memoire
//
//  Created by Thomas Jannaud on 31/08/08.
//  Copyright 2008 Jannaud's Technical Company. All rights reserved.
//

#import "Preference.h"


@implementation Preference

+(int) getRecord:(OptionDeJeu) opt {
	NSUserDefaults *preferences = [[NSUserDefaults standardUserDefaults] retain];

	if (opt == MortSubite)
		return [preferences integerForKey: @"ScoreMortSubite"];
	else if (opt == DeuxViesEnTout)
		return [preferences integerForKey: @"ScoreDeuxEnTout"];
	else
		return [preferences integerForKey: @"ScoreDeuxParTour"];
}

+(void) setRecord:(OptionDeJeu) opt: (int) r {
	if (opt == MortSubite)
		[Preference SavePref:r :@"ScoreMortSubite"];
	else if (opt == DeuxViesEnTout)
		[Preference SavePref:r :@"ScoreDeuxEnTout"];
	else
		[Preference SavePref:r :@"ScoreDeuxParTour"];
}

+(OptionDeJeu) getGameType {
	NSUserDefaults *preferences = [[NSUserDefaults standardUserDefaults] retain];
	if ([preferences boolForKey: @"MortSubite"] == 1)
		return MortSubite;
	else if ([preferences boolForKey: @"DeuxEnTout"] == 1)
		return DeuxViesEnTout;
	else
		return DeuxViesParTour;
}

+(void) setGameType:(OptionDeJeu) opt {
	[Preference SaveBoolPref:(opt == MortSubite):@"MortSubite"];
	[Preference SaveBoolPref:(opt == DeuxViesEnTout):@"DeuxEnTout"];
	[Preference SaveBoolPref:(opt == DeuxViesParTour):@"DeuxParTour"];
}

+(void) SavePref: (int)obj: (NSString*) cle {
	NSUserDefaults *preferences = [[NSUserDefaults standardUserDefaults] retain];
	[preferences setInteger:obj forKey:cle];
	[preferences synchronize];
}

+(void) resetRecords {
		[Preference SavePref:0 :@"ScoreMortSubite"];
		[Preference SavePref:0 :@"ScoreDeuxEnTout"];
		[Preference SavePref:0 :@"ScoreDeuxParTour"];
}

+(void) SaveBoolPref: (BOOL)obj: (NSString*) cle {
	NSUserDefaults *preferences = [[NSUserDefaults standardUserDefaults] retain];
	[preferences setBool:obj forKey:cle];
	[preferences synchronize];
}

+(void) initPref {
	NSUserDefaults *preferences = [[NSUserDefaults standardUserDefaults] retain];
	NSDictionary * values=[NSDictionary dictionaryWithObjectsAndKeys:
								  [NSNumber numberWithBool:YES],@"MortSubite",
								  [NSNumber numberWithBool:NO],@"DeuxParTour",
								  [NSNumber numberWithBool:NO],@"DeuxEnTout",
								  [NSNumber numberWithInt:0],@"ScoreMortSubite",
								  [NSNumber numberWithInt:0],@"ScoreDeuxParTour",
								  [NSNumber numberWithInt:0],@"ScoreDeuxEnTout", nil];
								  
	[preferences registerDefaults:values];	
	[preferences synchronize];
}

@end
